------------------------
------------------------
--                    --
--  Atlas             --
--  11/21/2005        --
--  Dan Gilbert       --
--  loglow@gmail.com  --
--                    --
------------------------
------------------------




-----------------------
-- support for myAddOns
-----------------------
AtlasDetails = {
	name = "Atlas",
	version = "1.3",
	releaseDate = "November 21, 2005",
	author = "Dan Gilbert",
	email = "loglow@gmail.com",
	website = "http://www.ocdproductions.net/Atlas/",
	category = MYADDONS_CATEGORY_MAP,
	optionsframe = "AtlasOptionsFrame"
};



AtlasOptions = {};
ATLAS_DROPDOWN_LIST = {};
local Atlas_Initialized = false;


function Atlas_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");
	tinsert(UISpecialFrames, "AtlasFrame");
	UIPanelWindows["AtlasFrame"] = nil;
	AtlasFrame:RegisterForDrag("LeftButton");
	SLASH_ATLAS1 = ATLAS_SLASH;
	SlashCmdList["ATLAS"] = function(msg)
		Atlas_SlashCommand(msg);
	end
end

-- optional removal of articles:
-- "The Deadmines" -> "Deadmines"
-- (thus will be sorted as under 'D', and not under 'T')
local function Atlas_SanitizeName(text)
       text = string.lower(text);
       if (AtlasSortIgnore) then
               for _,v in AtlasSortIgnore do
                       local match = string.gfind(text, v)();
                       if (match) then
                               return match;
                       end
               end
       end
       return text;
end

-- comparator function
local function Atlas_SortZones(a, b)
       local aa = Atlas_SanitizeName(AtlasText[a].ZoneName);
       local bb = Atlas_SanitizeName(AtlasText[b].ZoneName);
       return aa < bb;
end

function Atlas_UpdateLevelRanges()
	AtlasText.BlackfathomDeeps.LevelRange =		"24-32";
	AtlasText.BlackrockSpireLower.LevelRange =	"55-60";
	AtlasText.BlackrockSpireUpper.LevelRange =	"55-60";
	AtlasText.BlackrockDepths.LevelRange =		"52-60";
	AtlasText.ShadowfangKeep.LevelRange =		"22-30";
	AtlasText.ScarletMonastery.LevelRange =		"34-45";
	AtlasText.MoltenCore.LevelRange =		"60+";
	AtlasText.TheSunkenTemple.LevelRange =		"50-60";
	AtlasText.WailingCaverns.LevelRange =		"17-24";
	AtlasText.TheStockades.LevelRange =		"24-32";
	AtlasText.TheDeadmines.LevelRange =		"17-26";
	AtlasText.DireMaulNorth.LevelRange =		"56-60";
	AtlasText.DireMaulEast.LevelRange =		"56-60";
	AtlasText.DireMaulWest.LevelRange =		"56-60";
	AtlasText.Gnomeregan.LevelRange =		"29-38";
	AtlasText.RazorfenDowns.LevelRange =		"37-46";
	AtlasText.RazorfenKraul.LevelRange =		"29-38";
	AtlasText.Maraudon.LevelRange =			"46-55";
	AtlasText.OnyxiasLair.LevelRange =		"60+";
	AtlasText.BlackwingLair.LevelRange =		"60+";
	AtlasText.RagefireChasm.LevelRange =		"13-18";
	AtlasText.Scholomance.LevelRange =		"58-60";
	AtlasText.Stratholme.LevelRange =		"58-60";
	AtlasText.Uldaman.LevelRange =			"41-51";
	AtlasText.ZulFarrak.LevelRange =		"44-54";
	AtlasText.ZulGurub.LevelRange =			"60+";
end

function Atlas_UpdatePlayerLimits()
	AtlasText.BlackfathomDeeps.PlayerLimit =	10;
	AtlasText.BlackrockSpireLower.PlayerLimit =	15;
	AtlasText.BlackrockSpireUpper.PlayerLimit =	15;
	AtlasText.BlackrockDepths.PlayerLimit =		10;
	AtlasText.ShadowfangKeep.PlayerLimit =		10;
	AtlasText.ScarletMonastery.PlayerLimit =	10;
	AtlasText.MoltenCore.PlayerLimit =		40;
	AtlasText.TheSunkenTemple.PlayerLimit =		10;
	AtlasText.WailingCaverns.PlayerLimit =		10;
	AtlasText.TheStockades.PlayerLimit =		10;
	AtlasText.TheDeadmines.PlayerLimit =		10;
	AtlasText.DireMaulNorth.PlayerLimit =		5;
	AtlasText.DireMaulEast.PlayerLimit =		5;
	AtlasText.DireMaulWest.PlayerLimit =		5;
	AtlasText.Gnomeregan.PlayerLimit =		10;
	AtlasText.RazorfenDowns.PlayerLimit =		10;
	AtlasText.RazorfenKraul.PlayerLimit =		10;
	AtlasText.Maraudon.PlayerLimit =		10;
	AtlasText.OnyxiasLair.PlayerLimit =		40;
	AtlasText.BlackwingLair.PlayerLimit =		40;
	AtlasText.RagefireChasm.PlayerLimit =		10;
	AtlasText.Scholomance.PlayerLimit =		10;
	AtlasText.Stratholme.PlayerLimit =		10;
	AtlasText.Uldaman.PlayerLimite =		10;
	AtlasText.ZulFarrak.PlayerLimit =		10;
	AtlasText.ZulGurub.PlayerLimit =		20;
end

function Atlas_OnEvent()
	if(event == "VARIABLES_LOADED") then

		if (AtlasOptions.AtlasZone == nil) then
			AtlasOptions.AtlasZone = 1;
		end
		if (AtlasOptions.AtlasAlpha == nil) then
			AtlasOptions.AtlasAlpha = 1.0;
		end
		if (AtlasOptions.AtlasLocked == nil) then
			AtlasOptions.AtlasLocked = false;
		end
		if (AtlasOptions.AtlasMapName == nil) then
			AtlasOptions.AtlasMapName = true;
		end
		if (AtlasOptions.AtlasAutoSelect == nil) then
			AtlasOptions.AtlasAutoSelect = true;
		end
		if (AtlasOptions.AtlasButtonPosition == nil) then
			AtlasOptions.AtlasButtonPosition = 268;
		end
		if (AtlasOptions.AtlasButtonShown == nil) then
			AtlasOptions.AtlasButtonShown = true;
		end

		table.foreach(AtlasText, function(v)
			table.insert(ATLAS_DROPDOWN_LIST, v)
		end);

		table.sort(ATLAS_DROPDOWN_LIST, Atlas_SortZones);

		Atlas_UpdateLevelRanges();
		Atlas_UpdatePlayerLimits();
		Atlas_Refresh();
		AtlasOptions_Init();
		Atlas_UpdateLock();
		AtlasButton_UpdatePosition();
		Atlas_UpdateAlpha();

		Atlas_Initialized = true;

		-----------------------
		-- support for myAddOns
		-----------------------
 		if(myAddOnsFrame_Register) then
			myAddOnsFrame_Register(AtlasDetails);
		end

		---------------------
		-- support for Cosmos
		---------------------
		if(EarthFeature_AddButton) then
			EarthFeature_AddButton(
			{
				id = ATLAS_TITLE;
				name = ATLAS_NAME;
				subtext = ATLAS_SUBTITLE;
				tooltip = ATLAS_DESC;
				icon = "Interface\\AddOns\\Atlas\\Images\\AtlasIcon";
				callback = Atlas_Toggle;
				test = nil;
			}
		);
		elseif(Cosmos_RegisterButton) then
			Cosmos_RegisterButton(
				ATLAS_NAME,
				ATLAS_SUBTITLE,
				ATLAS_DESC,
				"Interface\\AddOns\\Atlas\\Images\\AtlasIcon",
				Atlas_Toggle
			);
		end

		--------------------
		-- support for CTMod
		--------------------
		if(CT_RegisterMod) then
			CT_RegisterMod(
				ATLAS_NAME,
				ATLAS_SUBTITLE,
				5,
				"Interface\\AddOns\\Atlas\\Images\\AtlasIcon",
				ATLAS_DESC,
				"switch",
				"",
				Atlas_Toggle
			);
		end
	end
end

function Atlas_ToggleLock()
	if(AtlasOptions.AtlasLocked) then
		AtlasOptions.AtlasLocked = false;
		Atlas_UpdateLock();
	else
		AtlasOptions.AtlasLocked = true;
		Atlas_UpdateLock();
	end
end

function Atlas_UpdateLock()
	if(AtlasOptions.AtlasLocked) then
		AtlasLockNorm:SetTexture("Interface\\AddOns\\Atlas\\Images\\LockButton-Locked-Up");
		AtlasLockPush:SetTexture("Interface\\AddOns\\Atlas\\Images\\LockButton-Locked-Down");
	else
		AtlasLockNorm:SetTexture("Interface\\AddOns\\Atlas\\Images\\LockButton-Unlocked-Up");
		AtlasLockPush:SetTexture("Interface\\AddOns\\Atlas\\Images\\LockButton-Unlocked-Down");
	end
end

function Atlas_StartMoving()
	if(not AtlasOptions.AtlasLocked) then
		AtlasFrame:StartMoving();
	end
end

function Atlas_SlashCommand(msg)
	if(msg == ATLAS_SLASH_OPTIONS) then
		AtlasOptions_Toggle();
	else
		Atlas_Toggle();
	end
end

function Atlas_UpdateAlpha()
	AtlasFrame:SetAlpha(AtlasOptions.AtlasAlpha);
end

function Atlas_Toggle()
	if(AtlasFrame:IsVisible()) then
		HideUIPanel(AtlasFrame);
	else
		ShowUIPanel(AtlasFrame);
	end
end

function Atlas_Refresh()
	local zoneID = ATLAS_DROPDOWN_LIST[AtlasOptions.AtlasZone];
	AtlasMap:ClearAllPoints();
	AtlasMap:SetWidth(512);
	AtlasMap:SetHeight(512);
	AtlasMap:SetPoint("TOPLEFT", "AtlasFrame", "TOPLEFT", 14, -71);
	AtlasMap:SetTexture("Interface\\AddOns\\Atlas\\Images\\"..zoneID);
	AtlasText_ZoneName:SetText(AtlasText[zoneID]["ZoneName"]);
	AtlasText_Location:SetText(ATLAS_STRING_LOCATION..": "..AtlasText[zoneID]["Location"]);
	AtlasText_LevelRange:SetText(ATLAS_STRING_LEVELRANGE..": "..AtlasText[zoneID]["LevelRange"]);
	AtlasText_PlayerLimit:SetText(ATLAS_STRING_PLAYERLIMIT..": "..AtlasText[zoneID]["PlayerLimit"]);
	for i = 1, 28, 1 do
		getglobal("AtlasText_"..i):SetText(AtlasText[zoneID][i]);
	end
end

function AtlasFrameDropDown_Initialize()
	local info;
	for i = 1, getn(ATLAS_DROPDOWN_LIST), 1 do
		info = {
			text = AtlasText[ATLAS_DROPDOWN_LIST[i]]["ZoneName"];
			func = AtlasFrameDropDownButton_OnClick;
		};
		UIDropDownMenu_AddButton(info);
	end
end



function AtlasFrameDropDown_OnShow()
	UIDropDownMenu_Initialize(AtlasFrameDropDown, AtlasFrameDropDown_Initialize);
	UIDropDownMenu_SetSelectedID(AtlasFrameDropDown, AtlasOptions.AtlasZone);
	UIDropDownMenu_SetWidth(175);
end


function AtlasFrameDropDownButton_OnClick()
	i = this:GetID();
	UIDropDownMenu_SetSelectedID(AtlasFrameDropDown, i);
	AtlasOptions.AtlasZone = i;
	Atlas_Refresh();
end

function Atlas_OnShow()
	if(AtlasOptions.AtlasAutoSelect) then
		local currentZone = GetRealZoneText();
		local currentMap = AtlasText[ATLAS_DROPDOWN_LIST[AtlasOptions.AtlasZone]]["ZoneName"];
		if(currentZone ~= currentMap) then
			for i = 1, getn(ATLAS_DROPDOWN_LIST), 1 do
				local mapName = AtlasText[ATLAS_DROPDOWN_LIST[i]]["ZoneName"];
				if(currentZone == mapName) then
					UIDropDownMenu_SetSelectedID(AtlasFrameDropDown, i);
					AtlasOptions.AtlasZone = i;
					Atlas_Refresh();
				end
			end
		end
	end
end
